#include<graphics.h>
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<DOS.h>

#define SQSIZE 30
#define DELAY 500

long count = 0;
void InitGraph(int&, int&);
int** MakeChessBoard(int);
int PlaceQueens(int**, int, int);
int CheckKill(int**, int, int, int);
void CreateChessBoard(int**, int);
void DeleteChessBoard(int**, int);
void PlaceQueen(int, int);
void RemoveQueen(int, int) ;
void HomeQueen(int);
void ShowFrontPage();
void Boundary();

int max_x, max_y;

void main()
{
	int** chessboard;
	int i, j, size;
	InitGraph(max_x, max_y);
	ShowFrontPage();
	cleardevice();
	Boundary();
	setcolor(9);
	settextstyle(8,0,5);
	for( i=0; i<15; i++)
		outtextxy(140-i,40-i,"N-Queen Problem");

	setcolor(12);
	for( i=0; i<8; i++)
		outtextxy(140-i,40-i,"N-Queen Problem");

	setcolor(10);
	for(i=0,j=0; i<5;i++,j+=35)
	{
		line(250,150+j,390,150+j);
		line(250+j,150,250+j,290);
	}
	setcolor(9);
	setfillstyle(SOLID_FILL, 9) ;
	pieslice(338,167,0,360, 4);
	pieslice(268,202,0,360, 4);
	pieslice(373,237,0,360, 4);
	pieslice(303,272,0,360, 4);

	do
	{
		setcolor(14);
		settextstyle(12,0,5);
		outtextxy(50,340,"Enter Size of chessBoard [Number of rows or columns ie. N]:");
		gotoxy(68,22);
		scanf("%d", &size);
		if (size < 4)
		{
			outtextxy(50,355,"There is NO solution for N<4 , Press any key and Enter again.");
			getch();
			setcolor(0);
			outtextxy(50,355,"There is NO solution for N<4 , Press any key and Enter again.");
		}
		if (size > 16)
		{
			outtextxy(50,355,"You ll not see the simulation for N>16, Press any key and Enter again.");
			getch();
			setcolor(0);
			outtextxy(50,355,"You ll not see the simulation for N>16, Press any key and Enter again.");
		}
	}while (size < 4 || size >16);
	chessboard = MakeChessBoard(size);
	CreateChessBoard(chessboard, size);
	PlaceQueens(chessboard, size, 0);
	getch();
	DeleteChessBoard(chessboard, size);
}
void Boundary()
{
	cleardevice();
	setcolor(13);
	rectangle(25,20,615,445);
	setfillstyle(11,10);
	for(int j=0;j<620;j=j+13)
	{
		// Top
		setcolor(3);
		circle(15+j,10,4);
		rectangle(10+j,5,20+j,15);
		floodfill(15+j,10,3);
		// Bottom
		circle(15+j,455,4);
		rectangle(10+j,450,20+j,460);
		floodfill(15+j,455,3);
		if(j<420 )
		{
			// Left
			circle(15,25+j,4);
			rectangle(10,20+j,20,30+j);
			floodfill(15,25+j,3);

			// Right
			circle(625,25+j,4);
			rectangle(620,20+j,630,30+j);
			floodfill(625,25+j,3);
		}
	}
}
void ShowFrontPage()
{
	int i,j;
	int midx = getmaxx() / 2,  midy = getmaxy() / 2;
	cleardevice();
	setcolor(5);
	settextstyle(8,0,5);
	for( i=0; i<15; i++)
		outtextxy(185-i,30-i,"SIMULATION");

	setcolor(9);
	for( i=0; i<8; i++)
		outtextxy(185-i,30-i,"SIMULATION");

	settextstyle(8,0,4);
	setcolor(9);
	for( i=0; i<10; i++)
	outtextxy(300-i,80-i,"of");
	setcolor(1);
	for( i=0; i<5; i++)
	outtextxy(300-i,80-i,"of");
	setcolor(9);
	for( i=0; i<10; i++)
	outtextxy(260-i,110-i,"NQueen");
	setcolor(1);
	for( i=0; i<5; i++)
	outtextxy(260-i,110-i,"NQueen");
	settextstyle(8,0,2);
	setcolor(14);
	outtextxy(200, 400, "Press ESC to continue");
	settextstyle(8,0,1);
	rectangle(midx-140,midy-70,460,320);
	setcolor(10);
	outtextxy(midx-130, midy-60, "Uddin Muhammad Khabir");
	outtextxy(midx-45, midy-40, "(03-03795-1)");
	outtextxy(midx-130, midy-20, "Kabir Md. Shahriar.");
	outtextxy(midx-45, midy, "(02-03437-3)");
	outtextxy(midx-130, midy+20, "Karim Mumtahina");
	outtextxy(midx-45, midy+40, "(02-0336-2)");
	setcolor(9);
	outtextxy(midx-180, midy+120, "Couse Teacher: MAHBOOB ALAM SIR");

	delay(1000);

	for(i=0;;i+=10)
	{
		if(kbhit())
			if(getch()==27)
				break;

		for(int j=0;!kbhit();j+=10)
		{
			setcolor(j);

			for(i=0;i<610;i+=6)
			{
				setcolor(getmaxcolor()-i);
				circle(10+i, 10, 8);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");

				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
				delay(5);
			}
			if(kbhit())
				break;

			for(i=0;i<610;i+=6)
			{
				setcolor(getmaxcolor()-i);
				circle(630, 10+i, 8);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

			}

			if(kbhit())
				break;

			for(i=610;i>0;i-=6)
			{
				setcolor(getmaxcolor()-i);
				circle(10+i, 470, 8);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}
			if(kbhit())
				break;

			for(i=610;i>0;i-=6)
			{
				setcolor(getmaxcolor()-i);
				circle(10, 10+i, 8);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}

			if(kbhit())
				break;

			for(i=0;i<610;i+=6)
			{
				circle(10+i, 10, 8);
				setcolor(i);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}
			if(kbhit())
				break;

			for(i=0;i<610;i+=6)
			{
				circle(630, 10+i, 8);
				setcolor(i);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}
			if(kbhit())
				break;

			for(i=610;i>0;i-=6)
			{
				circle(10+i, 470, 8);
				setcolor(i);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}
			if(kbhit())
				break;

			for(i=610;i>0;i-=6)
			{
				circle(10, 10+i, 8);
				setcolor(i);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");

				delay(5);
				setcolor(0);
				outtextxy(100,200,"A");
				outtextxy(103,220,"I");
				outtextxy(100,240,"U");
				outtextxy(100,260,"B");
				outtextxy(530,200,"A");
				outtextxy(533,220,"I");
				outtextxy(530,240,"U");
				outtextxy(530,260,"B");
			}
		}
	}
}
int** MakeChessBoard(int size)
{
	int** chessboard;
	int i, j;

	chessboard = (int * *) malloc(sizeof(int) * size);
	for (i = 0; i < size; i++)
		chessboard[i] = (int *) malloc(sizeof(int) * size);

	for (i = 0; i < size; i++)
		for (j = 0; j < size; j++)
			chessboard[i][j] = 0;

	return chessboard;
}
int PlaceQueens(int** chessboard, int size, int level)
{
	count++;
	int Q_placed = 0;

	int QNextLevel;
	int flag;
	int i;
	for (i = 0; i < size; i++)
	{
		if (Q_placed == 1)
			break;

		 flag = CheckKill(chessboard, size, level, i);

		 if (flag == 0)
		 {
			 Q_placed = 1;

			 chessboard[level][i] = 1;
			 PlaceQueen(level, i);

			 if (level == size - 1)
				;
			 else
			 {
				QNextLevel = PlaceQueens(chessboard, size, level + 1);

				if (QNextLevel == 0)
				{
					  Q_placed = 0;
					  chessboard[level][i] = 0;
					  RemoveQueen(level, i);
					  if (i == size - 1)
						HomeQueen(level);
				}
			 }
		 }
		 else if (flag == 1)
		 {
			PlaceQueen(level, i);
			RemoveQueen(level, i);
			if (i == size - 1)
				HomeQueen(level);
		 }
	}
	return Q_placed;
}
int CheckKill(int** chessboard, int size, int row, int column)
{
	int i, j;
	for (i = 0; i < row; i++)
		for (j = 0; j < size; j++)
			if (chessboard[i][j] == 1)
				if (j == column)
					return 1;

			else if (abs(i - row) == abs(j - column))
				return 1;
		return 0;
}
void CreateChessBoard(int** chessboard, int size)
{
	cleardevice();
	for (int i = 0; i < size; i++)
	{
		for (int j = 1; j <= size; j++)
		{
			if (i % 2 == j % 2)
				setfillstyle(SOLID_FILL, 12);
			else

				setfillstyle(SOLID_FILL, 14);
			bar(j * SQSIZE, i * SQSIZE, (j + 1) * SQSIZE, (i + 1) * SQSIZE);
		}
	}
	setcolor(10);
	rectangle(30, 0, max_x, max_y);
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 2);
	setcolor(WHITE);
}
void DeleteChessBoard(int** chessboard, int size)
{
	int i;
	for (i = 0; i < size; i++)
	free(chessboard[i]);
	free(chessboard);
}
void InitGraph(int& max_x, int& max_y)
{
	int gdriver = DETECT, gmode, errorcode;
	initgraph(&gdriver, &gmode, "E:\\tc\\bgi");

	errorcode = graphresult();
	if (errorcode != grOk)
	{
		printf("Graphics error:",grapherrormsg(errorcode));
		printf( "Press any key to halt:");
		getch();
		exit(1);
	}
	max_x = getmaxx();
	max_y = getmaxy();
}
void PlaceQueen(int row, int column)
{
	if (column == 0)
	{
		setfillstyle(SOLID_FILL, BLUE) ;
		setcolor(BLUE);
		pieslice(SQSIZE / 2, row * SQSIZE + SQSIZE / 2, 0, 360, 4);
	}
	delay(100);sound(400);delay(DELAY);nosound();
	setfillstyle(SOLID_FILL, 1) ;
	setcolor(1);
	pieslice((column + 1) * SQSIZE + SQSIZE / 2, row * SQSIZE + SQSIZE / 2, 0,360, 4);
	setfillstyle(SOLID_FILL, 0) ;
	setcolor(0);
	pieslice(SQSIZE / 2, row * SQSIZE + SQSIZE / 2, 0, 360, 4);
}
void RemoveQueen(int row, int column)
{
	delay(500);	sound(200); delay(DELAY+300); nosound();
	if (row % 2 != column % 2)
	{
		setcolor(12); setfillstyle(SOLID_FILL,12);
	}
	else
	{
		setcolor(YELLOW); setfillstyle(SOLID_FILL, YELLOW);
	}
	pieslice((column + 1) * SQSIZE + SQSIZE / 2, row * SQSIZE + SQSIZE / 2, 0,360, 4);
}
void HomeQueen(int row)
{
	setfillstyle(SOLID_FILL, BLUE) ;
	setcolor(BLUE);
	pieslice(SQSIZE / 2, row * SQSIZE + SQSIZE / 2, 0, 360, 4);
}